-------------------------------------------------------------------------------
-- Keyer Project
-- Jim Brady   Jan 2011
-- The license is FreeBSD, see the file "copying.txt"
--
-- This file has VHDL component declarations
-------------------------------------------------------------------------------



library IEEE;
   use IEEE.std_logic_1164.all;
   use IEEE.numeric_std.all;
   


package my_components is



   component uart_rx is
   port (
      clk           : in  std_logic;  
      reset         : in  std_logic;  
      rx            : in  std_logic;  
      strobe        : out std_logic;  
      dout          : out unsigned(7 downto 0));
   end component;
   
   
   
   component uart_tx is
   port (
      clk           : in  std_logic;  
      reset         : in  std_logic;  
      start_strobe  : in  std_logic;  
      wpm           : in  integer range 0 to 63;  
      tx            : out std_logic);  
   end component;




   component sidetone is
   port (
      clk           : in  std_logic;  
      reset         : in  std_logic;  
      enable        : in  std_logic;  
      spkr          : out std_logic);

   end component;
  
 
end package;
	
