-------------------------------------------------------------------------------
-- Keyer Project
-- Jim Brady   Jan 2011
-- The license is FreeBSD, see the file "copying.txt"
--
-- This module generates a 440Hz sidetone
------------------------------------------------------------------------------


library IEEE;
   use IEEE.std_logic_1164.all;
   use IEEE.numeric_std.all;
	

entity sidetone is
   port (
      clk        : in  std_logic;  -- 50MHz clock 
      reset      : in  std_logic;  -- South button
      enable     : in  std_logic;  -- Tone ON
      spkr       : out std_logic); -- Output to speaker

end sidetone;



architecture rtl of sidetone is
  
    
  
begin
 
--------------------------------------------------------------------------
-- This process makes a 440Hz tone in DOT/DASH states
--------------------------------------------------------------------------
   process (clk, reset)
      variable cnt : integer range 0 to 131071;
	   
   begin
      if (reset = '1') then
         cnt := 0;
		   spkr <= '0';
      
      elsif rising_edge(clk) then
         if (enable = '0') then
            cnt := 0;
            spkr <= '0';
         else
            -- Create a 440Hz output to speaker
		      cnt := cnt + 1;
	         case cnt is
               when 56818 =>  
               spkr <= '1';
                        
               when 113636 =>
	            spkr <= '0';
               cnt := 0;
            
               when others =>
               null;
            
            end case;
         end if;   
	   end if;	
      
   end process;
 
  
end rtl;

